#include "Sprite.h"
// #include "Chars.h"
#include "VVram.h"
#include "Vram.h"

constexpr byte SpriteWidth = 2;
constexpr byte SpriteHeight = 2;
constexpr byte Char_Space = 0x20;
constexpr byte InvalidY = 0x80;

struct Sprite {
    byte x, y;
    byte[SpriteWidth * SpriteHeight] chars;
};

Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(ptr<Movable> pMovable, ptr<byte> pChars)
{
    ptr<Sprite> pSprite;
    ptr<byte>pc;
    pSprite = Sprites + pMovable->sprite;
    pSprite->x = pMovable->x;
    pSprite->y = pMovable->y;
    pc = pSprite->chars;
    repeat (SpriteWidth * SpriteHeight) {
        *pc = *pChars;
        ++pc;
        ++pChars;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> pSprite;
    pSprite = Sprites + index;
    pSprite->y = InvalidY;
}


void DrawSprites()
{
    ptr<Sprite> pSprite;
    for (pSprite : Sprites) {
        if (pSprite->y != InvalidY) {
            ptr<byte> pVVram;
            ptr<byte> pChars;
            pVVram = VVramPtr(pSprite->x, pSprite->y);
            pChars = pSprite->chars;
            repeat (SpriteHeight) {
                repeat (SpriteWidth) {
                    byte c;
                    c = *pChars; ++pChars;
                    if (c != Char_Space) {
                        *pVVram = c;
                    }
                    ++pVVram;
                }
                pVVram += VVramWidth - SpriteWidth;
            }
        }
    }
}
