#include "Status.h"
#include "Vram.h"
#include "Stage.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
// #include "Chars.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    static const byte[] RemainChars = {
        0x80, 0x20, 0xa3, 0xaa,
    };

    PrintS(Vram + 5, "SCORE"); 
    // PrintS(Vram + 7, "HI-SCORE");
    PrintS(Vram + 11, "STAGE");
    PrintByteNumber2(Vram + VramRowSize + 13, CurrentStage + 1);
    PrintS(Vram+ 17, "TIME");

    {
        ptr<byte> pVram;
        pVram = Vram + 23;
        if (RemainCount > 1) {
            byte i;
            i = RemainCount - 1;
            do {
                ptr<byte> pChars;
                pChars = RemainChars;
                repeat (2) {
                    repeat (2) {
                        *pVram = *pChars;
                        ++pVram;
                        ++pChars;
                    }
                    pVram += VramRowSize - 2;
                }
                pVram += 2 - VramRowSize * 2;
                --i;
            } while (i > 0);
        }
    }

    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize + 4, Score);
    PrintC(pVram, '0');

    // pVram = PrintNumber5(Vram + VramRowSize + 9, HiScore);
    // PrintC(pVram, '0');
}

void PrintTime()
{
    PrintByteNumber3(Vram + VramRowSize + 18, StageTime);
}


void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 9 + 11, "GAME OVER");
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 9 + 12, "TIME UP");
}

void Title()
{
    static const byte[] TitleBytes = {
        //	L
        0x83, 0x82, 0x20, 0x20, 
        0x83, 0x82, 0x20, 0x20, 
        0x83, 0x82, 0x20, 0x20, 
        0xab, 0x90, 0x90, 0xac, 
        //	I
        0xab, 0x80, 0x80, 0xac, 
        0x20, 0x83, 0x82, 0x20, 
        0x20, 0x83, 0x82, 0x20, 
        0xab, 0x90, 0x90, 0xac, 
        //	F
        0x83, 0x80, 0x90, 0xac, 
        0x83, 0x80, 0x91, 0xaa, 
        0x83, 0x82, 0x20, 0x20, 
        0xab, 0xac, 0x20, 0x20, 
        //	T
        0xab, 0x80, 0x80, 0xac, 
        0x20, 0x83, 0x82, 0x20, 
        0x20, 0x83, 0x82, 0x20, 
        0x20, 0xab, 0xac, 0x20, 
    };

    ClearScreen(); 
    HideAllSprites();
    PrintStatus(); 
    {
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 4 + 8;
        p = TitleBytes;
        repeat (4) {
            repeat (4) {
                repeat (4) {
                    *pVram = *p;
                    ++pVram;
                    ++p;
                }
                pVram += VramRowSize - 4;
            }
            pVram += 4 - VramRowSize * 4;
        }
        PrintS(Vram + VramRowSize * 8 + 20, "MINI");
    }
    PrintS(Vram + VramRowSize * 11 + 9, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 12 + 9, "OR 'Z' KEY");
    // PrintS(Vram + VramRowSize * 14 + 16, "INUFUTO 2023");
}